#ifndef LCD_H
#define LCD_H

#include <linux/ioctl.h>

#define DEVICE_MAJOR 250
#define DEVICE_NAME "lcd"

/* ioctl definitions. */

#define LCD_CLEAR_DISPLAY	_IOR( DEVICE_MAJOR, 0, NULL )
#define LCD_CURSOR_HOME		_IOR( DEVICE_MAJOR, 1, NULL )
#define LCD_ENTRY_MODE		_IOR( DEVICE_MAJOR, 2, unsigned char )
#define LCD_DISPLAY_MODE	_IOR( DEVICE_MAJOR, 3, unsigned char )
#define LCD_DISPLAY_SHIFT	_IOR( DEVICE_MAJOR, 4, unsigned char )
#define LCD_FUNCTION_SET	_IOR( DEVICE_MAJOR, 5, unsigned char )
#define LCD_RESET		_IOR( DEVICE_MAJOR, 6, NULL )
#define LCD_SET_DDRAM_ADDR	_IOR( DEVICE_MAJOR, 7, unsigned char )
/* Flags for the LCD_ENTRY_MODE */
#define LCD_ENTRY_DECREMENT	0x00  /* Cursor moves left */
#define LCD_ENTRY_INCREMENT	0x02  /* Cursor moves right */
#define LCD_ENTRY_LEFT		0x01  /* Display moves instead of cursor */
#define LCD_ENTRY_RIGHT		0x03

/* Flags for the LCD_DISPLAY_MODE ioctl */
#define LCD_DISPLAY_DISPLAY	0x04
#define LCD_DISPLAY_CURSOR	0x02
#define LCD_DISPLAY_BLINK	0x01 

/* Flags for the LCD_DISPLAY_SHIFT ioctl */
#define LCD_CURSOR_RIGHT	0x00
#define LCD_CURSOR_LEFT	0x04
#define LCD_SHIFT_RIGHT 0x0C
#define LCD_SHIFT_LEFT	0x08

/* Addresses for LCD_SET_DDRAM_ADDR */
#define LCD_DDRAM_ADDR_LINE1	0x00
#define LCD_DDRAM_ADDR_LINE2	0x40
#endif
